org.apache.hc.core5.http2.impl.nio.bootstrap

## Class H2AsyncRequester

- java.lang.Object
- - org.apache.hc.core5.http.impl.bootstrap.AsyncRequester
  - - org.apache.hc.core5.http.impl.bootstrap.HttpAsyncRequester
    - - org.apache.hc.core5.http2.impl.nio.bootstrap.H2AsyncRequester

- All Implemented Interfaces:
    Closeable, AutoCloseable, ModalCloseable, ConnPoolControl<HttpHost>, ConnPoolStats<HttpHost>, ConnectionInitiator, IOReactor, IOReactorService

      public class H2AsyncRequester
      extends HttpAsyncRequester

  Client side message exchange initiator capable of negotiating HTTP/2 or HTTP/1.1 compatible connections.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `H2AsyncRequester(HttpVersionPolicy versionPolicy, IOReactorConfig ioReactorConfig, IOEventHandlerFactory eventHandlerFactory, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, ManagedConnPool<HttpHost,IOSession> connPool)` Use `H2RequesterBootstrap` to create instances of this class.
    `H2AsyncRequester(HttpVersionPolicy versionPolicy, IOReactorConfig ioReactorConfig, IOEventHandlerFactory eventHandlerFactory, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, ManagedConnPool<HttpHost,IOSession> connPool, TlsStrategy tlsStrategy, Timeout handshakeTimeout)` Use `H2RequesterBootstrap` to create instances of this class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Future<IOSession>` | `connect(NamedEndpoint remoteEndpoint, SocketAddress remoteAddress, SocketAddress localAddress, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)` Requests a connection to a remote host.
    `protected Future<AsyncClientEndpoint>` | `doConnect(HttpHost host, Timeout timeout, Object attachment, FutureCallback<AsyncClientEndpoint> callback)`
    `protected void` | `doTlsUpgrade(ProtocolIOSession ioSession, NamedEndpoint endpoint, FutureCallback<ProtocolIOSession> callback)`

    - ### Methods inherited from class org.apache.hc.core5.http.impl.bootstrap.HttpAsyncRequester

      `closeExpired, closeIdle, connect, connect, execute, execute, execute, execute, execute, execute, execute, execute, getDefaultMaxPerRoute, getMaxPerRoute, getMaxTotal, getRoutes, getStats, getTotalStats, setDefaultMaxPerRoute, setMaxPerRoute, setMaxTotal`

    - ### Methods inherited from class org.apache.hc.core5.http.impl.bootstrap.AsyncRequester

      `awaitShutdown, close, close, defaultTarget, getStatus, initiateShutdown, requestSession, start`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### H2AsyncRequester

          @Internal
          public H2AsyncRequester(HttpVersionPolicy versionPolicy,
                                            IOReactorConfig ioReactorConfig,
                                            IOEventHandlerFactory eventHandlerFactory,
                                            Decorator<IOSession> ioSessionDecorator,
                                            Callback<Exception> exceptionCallback,
                                            IOSessionListener sessionListener,
                                            ManagedConnPool<HttpHost,IOSession> connPool)

      Use `H2RequesterBootstrap` to create instances of this class.

    - #### H2AsyncRequester

          @Internal
          public H2AsyncRequester(HttpVersionPolicy versionPolicy,
                                            IOReactorConfig ioReactorConfig,
                                            IOEventHandlerFactory eventHandlerFactory,
                                            Decorator<IOSession> ioSessionDecorator,
                                            Callback<Exception> exceptionCallback,
                                            IOSessionListener sessionListener,
                                            ManagedConnPool<HttpHost,IOSession> connPool,
                                            TlsStrategy tlsStrategy,
                                            Timeout handshakeTimeout)

      Use `H2RequesterBootstrap` to create instances of this class.
      Since:
        5.2

  - ### Method Detail

    - #### doConnect

          protected Future<AsyncClientEndpoint> doConnect(HttpHost host,
                                                          Timeout timeout,
                                                          Object attachment,
                                                          FutureCallback<AsyncClientEndpoint> callback)

      Overrides:
        `doConnect` in class `HttpAsyncRequester`

    - #### doTlsUpgrade

          protected void doTlsUpgrade(ProtocolIOSession ioSession,
                                      NamedEndpoint endpoint,
                                      FutureCallback<ProtocolIOSession> callback)

      Overrides:
        `doTlsUpgrade` in class `HttpAsyncRequester`

    - #### connect

          public final Future<IOSession> connect(NamedEndpoint remoteEndpoint,
                                                 SocketAddress remoteAddress,
                                                 SocketAddress localAddress,
                                                 Timeout timeout,
                                                 Object attachment,
                                                 FutureCallback<IOSession> callback)

      Description copied from interface: `ConnectionInitiator`
      Requests a connection to a remote host.

      Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `Future` interface.

      There are several parameters one can use to exert a greater control over the process of session initialization:

      A non-null local socket address parameter can be used to bind the socket to a specific local address.

      An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

      It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `FutureCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

      Specified by:
        `connect` in interface `ConnectionInitiator`
      Parameters:
        `remoteEndpoint` - name of the remote host.
        `remoteAddress` - remote socket address.
        `localAddress` - local socket address. Can be `null`, in which can the default local address and a random port will be used.
        `timeout` - connect timeout.
        `attachment` - the attachment object. Can be `null`.
        `callback` - interface. Can be `null`.
      Returns:
        session request object.

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.